<template>
  <div class="input-form">
    <Field :name="name" v-slot="{ field, meta }">
      <input
        v-bind="field"
        :class="meta.touched && !meta.valid && 'invalid'"
        :placeholder="placeholder"
      />
    </Field>
    <ErrorMessage class="error" :name="name" />
  </div>
</template>

<script lang="ts" setup>
import { Field, ErrorMessage } from "vee-validate";

export interface Props {
  name: string;
  placeholder?: string;
}

const props = defineProps<Props>();
</script>

<style scoped lang="scss">

.input-form {
  margin-bottom: 12px;
}

input {
  height: 36px;
  width: 100%;
  display: block;
  padding: 8px 12px;
  background-color: white;
  border-radius: 6px;
  box-shadow: 0 1px 2px 0 rgb(0 0 0 / 0.05);
  border: 1px solid rgb(226 232 240);
  outline: none;
  animation: transition 0.3s linear;

  &:focus {
    border: 1px solid rgb(71 85 105);
  }

  &.invalid {
    border: 1px solid rgb(239 68 68);

    &:focus {
      border: 1px solid rgb(185 28 28);
    }
  }
}
.error {
  color: rgb(239 68 68);
  padding-left: 12px;
  font-size: 12px;
}
</style>
